Graphics3D 640,480,16,2
	SeedRnd MilliSecs()
Global TotalVertex%;						 
Global TotalEdges%;						 
Global StartPoint%;						 
Global FinishPoint%;						 
Global WaypointsInPath%;					   
Const VeryBigConst% = 32767

SetFont LoadFont("Arial",14)
DrawImage LoadImage("graf4.jpg"),300,10
;		====================================
mapfile = ReadFile("map4.txt")
	mf_str = ReadLine(mapfile)
		TotalVertex = Int(mf_str)
	mf_str = ReadLine(mapfile)
		TotalEdges = Int(mf_str)

		StartPoint = Rand(0,TotalVertex-1)
		FinishPoint = Rand(0,TotalVertex-1)

Dim Graf(TotalVertex,TotalVertex);			  
Dim Label(TotalVertex);						 
Dim Active(TotalVertex);					 "-"
Dim Parent(TotalVertex);					 
Dim Path(TotalVertex);						   

For ij=0 To TotalEdges-1
		gi = Int(ReadLine(mapfile))
		gj = Int(ReadLine(mapfile))
		gv = Int(ReadLine(mapfile))
		Graf(gi,gj) = gv
		Graf(gj,gi) = gv
Next

CloseFile(mapfile)


Print "-----Map Info------"
Print "TotalVertex: "+TotalVertex
Print "TotalEdges: "+TotalEdges
Print "StartPoint: "+StartPoint
Print "FinishPoint: "+FinishPoint
Print "---------------------"

For ij=0 To TotalVertex-1
	Label(ij) = VeryBigConst
Next

;		====================================

FindMinWay();							   StartPoint  FinishPoint

Print "---------- Length of way ---------"
Print "The way from "+StartPoint+" to "+FinishPoint+" is: "+Label(FinishPoint)
Print "--------------------------------------"

j = FinishPoint
i = 1
Path(0) = FinishPoint
While Not j=StartPoint
	Path(i) = Parent(j)
	j = Parent(j)
	i = i + 1
Wend
j = i - 1
i = 0


Print "----------- Way points -----------"
While j>=0
	Write Path(j) + " "
	j = j - 1
Wend
Print " "
Print "--------------------------------------"

WaitMouse()


Function FindMinWay()

Active(StartPoint) = 1
Label(StartPoint) = 0
i = StartPoint
		
		
While Not i=-1
	For j=0 To TotalVertex-1
		If Graf(i,j)>0 And Label(j)>Label(i)+Graf(i,j) Then
			Active(j) = 1
			Label(j)=Label(i)+Graf(i,j)
			Parent(j) = i
		EndIf

	Next		
		Active(i) = 0
		i = FindMinVertex()
Wend

End Function


Function FindMinVertex%()

Local min% = VeryBigConst
Local k%
Local min_pos% = -1

For k=0 To TotalVertex-1
	If Label(k)<min And Active(k)=1 Then
		min = Label(k)
		min_pos = k
	EndIf
Next

	Return min_pos

End Function


